SuperStrict

Rem
	bbdoc: Motherclass.
	about: This module provides a mother class (#TObject) from which i can inherit everything.
Endrem
Module siliziumbrain.uberobject
ModuleInfo "Version: v1.01"
ModuleInfo "Author: M0rgenstern - Siliziumbrain - Kevin Peter Hoffeld"
ModuleInfo "License: Public Domain"
ModuleInfo "History v1.00: 12 July 2012 - Final Release"
ModuleInfo "History v1.01: 13 July 2012 - Removed HashCode() because it is not needed."

rem
	bbdoc: TObject class.
	about: Every of my future types will inherit from this class.
endrem
Type TObject Abstract
	rem
		bbdoc: Checks if two objects are equal.
		about: Every child class has to implement this method. <br>
		returns: %True if objects @this und @ptoOtherObject are equal, %false otherwise.
	endrem
	Method Equals:Byte(ptoOtherObject:TObject) Abstract
	
	rem
		bbdoc: Returns the Object as a string.
		about: Method has to be implemented by each child class. <br>
		In #TObject the method just returns the instance name. <br>
		returns: The Object as a string.
	endrem
	Method ToString:String()
		Return Super.ToString()
	End Method
	
	rem
		bbdoc: Copies the object.
		about: A deep (as far as possible) copy of the object is made. <br>
		returns: A deep copy of the object.
	endrem
	Method Copy:TObject() Abstract
End Type